package com.company.cubademo.web.charts;

import com.haulmont.charts.gui.components.charts.PieChart;
import com.haulmont.charts.gui.data.MapDataItem;
import com.haulmont.cuba.core.entity.KeyValueEntity;
import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.gui.screen.Screen;
import com.haulmont.cuba.gui.screen.Subscribe;
import com.haulmont.cuba.gui.screen.UiController;
import com.haulmont.cuba.gui.screen.UiDescriptor;

import javax.inject.Inject;
import java.util.List;


@UiController("cubademo_Chartstest")
@UiDescriptor("chartstest.xml")
public class Chartstest extends Screen {

    @Inject
    private PieChart pie3Chart;

    @Inject
    DataManager dataManager;

    @Subscribe
    private void onBeforeShow(BeforeShowEvent event) {
        List<KeyValueEntity> list = dataManager.loadValues(
                "select e.deviceType.name,count(e.deviceType) from cubademo_Device e group by e.deviceType"
        ).properties("deviceType","amount").list();

        for (KeyValueEntity keyValueEntity:list){
            pie3Chart.addData(MapDataItem.of("key",keyValueEntity.getValue("deviceType"),"value",keyValueEntity.getValue("amount")));
        }
    }



}